;   1   
; lgt8f328P,  8 
.include "lgt8f328Pdef.inc"
.equ K_div = 250 ;   
.def rK_div = r16 ;   
.def count = r17 ; 
.def temp = r18 ; 
.def temp2 = r19 ; 
. . . . .
;=====  
rjmp Reset ; 
.org OVF0addr ;  OVF0addr   Timer0
rjmp TIM0_OVF
.org INT_VECTORS_SIZE ;      
;======  

TIM0_OVF: ; Timer0
 inc count 
 sbrs count,1 ; bit1 =1, 
 sbr temp,0b01000000 ;   6
 sbrc count,1 ; bit1=0, 
 cbr temp,0b01000000 ;   6
 out PortD,temp ;   D
 out TCNT0,rK_div ;""    
reti ;  

delay:
	dec count
	brne 	delay 	
 ret
 
Reset:
 ldi temp,low(RAMEND) ;  
 out SPL,temp
ldi temp,high(RAMEND) ;  
 out SPH,temp
 
  ;====== Set external quartz 0.4 -32 MHz ======
 	clr temp
	clr temp2	
	ldi temp, 0x80	;enable external crystal
	lds temp2, PMCR		
	ori temp2, 0x04
	sts PMCR, temp
	sts PMCR, temp2	
	ser count ;=$FF
	rcall delay	;waiting for crystal stable 256 clocks

 	clr temp
	clr temp2	
 	ldi temp, 0x80	;switch to external crystal	
	lds temp2, PMCR			
	andi temp2, 0x9f
	ori temp2, 0x20
	sts PMCR, temp
	sts PMCR, temp2	
	ser count ;=$FF
	rcall delay	;waiting for crystal stable  256 clocks

	ldi temp, 0x80			;set to right prescale
	ldi temp2, 0x00	;0x20 - out system clock to PB0
	sts CLKPR, temp
	sts CLKPR, temp2
	nop
	nop
	nop	
  ;=====end set quartz ===

 
 ldi temp,0b01000000 ;   D  
 out DDRD,temp 
 clr count ; 
 clr temp ;
 ldi temp,(1<<TOIE0) ;.  Timer0 Overflow 
 sts TIMSK0,temp
 ldi rK_div,K_div ; .  (250)
 neg rK_div ;256-K_div, . .  
 out TCNT0,rK_div ;""    
 ldi temp,0b00000010 ;Timer0  1:8
 out TCCR0B,temp
sei
Cykle:
rjmp cykle
