; lgt8f328P,  8 
.include "lgt8f328Pdef.inc"
.def temp = r16 ; 
.def temp2 = r17 ; 
; ============== interrupts ==============
rjmp RESET ;Reset Handler
.org TC3INTaddr ;  TC3INTaddr  Timer3
rjmp  TIM3_INT
.org INT_VECTORS_SIZE ;      
;======  
; ============== code ==============

TIM3_INT: ;   3
sbi TIFR3,TOV3 ;   
;  :
 ldi temp,high(3036)
 sts TCNT3H,temp
 ldi r16,low(3036)
 sts TCNT3L,temp
;   
 in temp,PortD ;  temp  PortD 
 sbrc temp,5 ; PD5  0, .  
 rjmp set_Red ;   
 sbi PortD,5 ;PD5=1,  
 cbi PortD,6 ;PD6=0,      
reti ;  
set_Red: ;    
 cbi PortD,5 ;PD5=0,  
 sbi PortD,6 ;PD6=1,   
reti ;  


delay:
	dec temp2
	brne 	delay 	
 ret
  
RESET: ;   
ldi temp,low(RAMEND) ;  
 out SPL,temp
ldi temp,high(RAMEND) ;  
 out SPH,temp

 ;====== Set external quartz 0.4 -32 MHz ======
 	clr temp
	clr temp2	
	ldi temp, 0x80	;enable external crystal
	lds temp2, PMCR		
	ori temp2, 0x04 
	sts PMCR, temp
	sts PMCR, temp2	
	ser temp2 ;=$FF
	rcall delay	;waiting for crystal stable 256 clocks

 	clr temp
	clr temp2	
 	ldi temp, 0x80	;switch to external crystal	
	lds temp2, PMCR			
	andi temp2, 0x9f
	ori temp2, 0x20
	sts PMCR, temp
	sts PMCR, temp2	
	ser temp2 ;=$FF
	rcall delay	;waiting for crystal stable  256 clocks

	ldi temp, 0x80			;set to right prescale
	ldi temp2, 0x20	;0x20 - out system clock to PB0
	sts CLKPR, temp
	sts CLKPR, temp2
	nop
	nop
	nop	
  ;=====end set quartz ===

 ldi temp,0b01100000 ;  5  6 
 out DDRD,temp ;       D
 
 ldi temp,0b00000011 ; temp
 sts TCCR3B,temp ; Timer 3   1/64 
 ldi temp,high(3036)
sts TCNT3H,temp
 ldi r16,low(3036)
sts TCNT3L,temp
 ldi temp,(1<<TOIE3) ;  TOIE3 
 sts TIMSK3,temp ;  Timer 3  
sei ;  
Cykle: 
rjmp Cykle ; 
