//программа мигания по таймеру

volatile byte countT=0;//счетчик для таймера
volatile unsigned char flagKey=0; //вспомогательная переменная - флаг 
const int ledRedPin = 19;  //Led красный
const int ledGreenPin = 18;  //Led зеленый

void setup() {
  pinMode (ledRedPin, OUTPUT);
  pinMode (ledGreenPin, OUTPUT);
}

ISR(TIMER2_OVF_vect) 
{//мигалка
countT--;
if (countT!=0) return;
if (flagKey != 0)
{
  digitalWrite(ledRedPin,LOW);
  digitalWrite(ledGreenPin, !digitalRead(ledGreenPin));   // включаем/выключаем зеленый 
} else
{
  digitalWrite(ledGreenPin,LOW);
  digitalWrite(ledRedPin, !digitalRead(ledRedPin));   // включаем/выключаем красный 
}
} //end ISR

void Timer2start ()
{ //пуск Timer2
TCCR2B = (1<<CS22)|(0<<CS21);
//Timer 2 счет 1/256
    bitSet(TIMSK2, TOIE2);//разрешаем прерывания overflow
}
void Timer2stop() //стоп Timer2
{    bitClear(TIMSK2, TOIE2);//запрещаем прерывания overflow
  digitalWrite(ledRedPin,LOW); //оба светодиода погашены
  digitalWrite(ledGreenPin,LOW);
 }

void loop() {
  Timer2start(); //запускаем Timer2
  flagKey=0; //мигаем красным 5 сек
  delay(5000);
  flagKey=1; //мигаем зеленым 5 сек
  delay(5000);
  Timer2stop();//останавливаем
  delay(5000); //на 5 сек
}
