//LGT8F328P 16 МГц
//простейшая проверка приема 
//при приеме правильного числа 2948 (см. передатчик) 
//светодиод переключается


#define Ledpin 13
#define RX 5 //Определяем вывод RX (TX на модуле)
#define TX 6 //Определяем вывод TX (RX на модуле)

#include <SoftwareSerial.h> //библиотека программного последовательного порта
SoftwareSerial Serialpr(RX,TX);           

word value; //присланное число в буфере 

void setup() {
Serialpr.begin(9600);
Serial.begin(9600); //для отладки
pinMode(Ledpin,OUTPUT);
}

void loop() {
    if (Serialpr.available() > 0) {
        // Пришла! Считываем её и анализируем
   byte bb = Serialpr.read(); //мл. байт
   Serial.println(bb,HEX); //для отладки
   value = Serialpr.read(); //ст. байт
   Serial.println(value,HEX); //для отладки
   value = value*256+bb; //присланное число
   Serial.println(value); //для отладки
  if (value==273) {
    //если равно посланному числу, то переключаем состояние LED
    digitalWrite(Ledpin,!digitalRead(Ledpin)); 
    }
  }
}
